	; FC Sound Sequencer lite

FSSQL_BGM_TRACK_SIZE	.equ	4
FSSQL_SE_TRACK_SIZE	.equ	1
FSSQL_TRACK_SIZE	.equ	(FSSQL_BGM_TRACK_SIZE+FSSQL_SE_TRACK_SIZE)
FSSQL_DRUM_PITCH	.equ	300

; _FSSQL_CCTRL  unt----s
; u: XV̂(SEɊ肱܂ĂBGMCH)
; n: mCYCH
; t: OpgCH
; s: SE

_FSSQL_WORK	.equ	FNC_WORK    ; 3bytes
_FSSQL_CCTRL	.equ	FNC_WORK+3
_FSSQL_SEQ	.equ	FNC_WORK+4  ; 2bytes
_FSSQL_LENTBL	.equ	FNC_WORK+6  ; 2bytes
_FSSQL_TR_INX	.equ	FNC_WORK+8
_FSSQL_CH_INX	.equ	FNC_WORK+9
_FSSQL_CH_BIT	.equ	FNC_WORK+10
_FSSQL_TICK	.equ	FNC_WORK+11

; FSSQL_STAT    ---bbbb
; FSSQL_STAT+1  ---eeee
; FSSQL_STAT+2  ---nnnn
; FSSQL_STAT+3  ---mmmm
; b: BGMgpĂCHBitmap
; e: SE gpĂCHBitmap
; n: BGMCHBitmap(x≹ʃ[CHbitȂ)
; m: SE CHBitmap(x≹ʃ[CHbitȂ)

FSSQL_STAT	.equ	$bc ;   4 bytes
FSSQL_REF	.equ	$c0 ;   2 bytes
FSSQL_NCNT	.equ	$c2 ;   5 bytes (TR)
FSSQL_DMC	.equ	$c7
FSSQL_TREG2	.equ	$c8 ; 4*2 bytes (CH)


FSSQL_TBASE	.equ	$01d0 ;   5 bytes (TR)
FSSQL_LBASE	.equ	$01d5 ;   5 bytes (TR)
; Init$ff(from)
FSSQL_CH	.equ	$01da ;   5 bytes (TR)
; Init$ff(to)
; free $01df

; InitŃ[(from)
FSSQL_LENTBL_L	.equ	$0300 ;   2 bytes
FSSQL_LENTBL_H	.equ	$0302 ;   2 bytes
FSSQL_LOOP_CNT	.equ	$0304
FSSQL_TCNT	.equ	$0305
FSSQL_TEMPO	.equ	$0306
FSSQL_SEQ_L	.equ	$0307 ;   5 bytes (TR)
FSSQL_SEQ_H	.equ	$030c ;   5 bytes (TR)
FSSQL_ENV	.equ	$0311 ;   5 bytes (TR)
FSSQL_REG1	.equ	$0316 ;   5 bytes (TR)
FSSQL_FADEOUT	.equ	(FSSQL_REG1+2)
FSSQL_TREG1	.equ	$031b ; 4+2 bytes (CH)
FSSQL_PAUSE	.equ	(FSSQL_TREG1+2)
; InitŃ[(to)
FSSQL_KEYON	.equ	$0321 ;   5 bytes (TR)
FSSQL_LCNT	.equ	$0326 ;   5 bytes (TR)
FSSQL_REG2	.equ	$032b ;   5 bytes (TR) L惊s[g̃[vJE^ƌp
FSSQL_S_SEQ_L	.equ	$0330 ;   4 bytes (BGM TR)
FSSQL_S_SEQ_H	.equ	$0334 ;   4 bytes (BGM TR)
FSSQL_S_TBASE	.equ	$0338 ;   4 bytes (BGM TR)
FSSQL_S_LBASE	.equ	$033c ;   4 bytes (BGM TR)


Fssql_DataTable:
.align1:
	.org	(HIGH(.align1-1)+1)*256

; 1789772.5        120HzTv 64byte
;  0 428  4181.71Hz   34.85        122.44msec
;  1 380  4709.93Hz   39.25        108.71msec
;  2 340  5264.04Hz   43.87         97.26msec
;  3 320  5593.04Hz   46.61         91.54msec
;  4 286  6257.95Hz   52.15         81.82msec
;  5 254  7046.35Hz   58.72         72.66msec
;  6 226  7919.35Hz   65.99         64.65msec
;  7 214  8363.42Hz   69.70         61.22msec
;  8 190  9419.86Hz   78.50         54.35msec
;  9 160 11186.08Hz   93.22         45.77msec
; 10 142 12604.03Hz  105.03         40.62msec
; 11 128 13982.60Hz  116.52         36.62msec
; 12 106 16884.65Hz  140.71         30.32msec
; 13  85 21056.15Hz  175.47         24.32msec
; 14  72 24857.95Hz  207.15         20.60msec
; 15  54 33143.94Hz  276.20         15.45msec

	; Bass   9 160 96smp/116.52Hz 192smp/ 58.26Hz
	; Snare 12 106 96smp/175.88Hz 192smp/ 87.94Hz
	; Tam   14  72 96smp/258.94Hz 192smp/129.47Hz
	; smp:   96, 112, 136, 160, 192
	; vol:   24,  20,  16,  12,   8
	; st:     0,  12,  26,  43,  63
Fssql_Dpcm:
	; pۂ߂`g
	.db	$ff,$ff,$ff,$ff,$ff,$ff,$00,$00
	.db	$00,$00,$00,$00
	.db	                $77,$ff,$ff,$ff
	.db	$ff,$77,$55,$44,$00,$00,$00,$00
	.db	$44,$55
	.db	        $77,$ff,$ff,$ff,$77,$55
	.db	$55,$55,$45,$04,$00,$00,$40,$54
	.db	$55,$55,$55
	.db	            $77,$77,$ff,$77,$77
	.db	$55,$55,$55,$55,$55,$44,$44,$00
	.db	$44,$44,$55,$55,$55,$55,$55
	.db	                            $77
	.db	$77,$77,$77,$55,$55,$55,$55,$55
	.db	$55,$55,$55,$44,$44,$44,$44,$55
	.db	$55,$55,$55,$55,$55,$55,$55
	.db	                            $15
	.db	$15,$15,$15,$15,$15,$15,$15,$15
	.db	$15

	;^Opg
;	.db	$ff,$ff,$ff,$ff,$ff,$ff,$00,$00
;	.db	$00,$00,$00,$00
;	.db	                $7f,$7f,$7f,$7f
;	.db	$7f,$7f,$5f,$40,$40,$40,$40,$40
;	.db	$40,$50
;	.db	        $77,$77,$77,$77,$77,$77
;	.db	$77,$77,$45,$44,$44,$44,$44,$44
;	.db	$44,$44,$54
;	.db	            $d7,$75,$5d,$d7,$75
;	.db	$5d,$d7,$75,$5d,$55,$14,$45,$51
;	.db	$14,$45,$51,$14,$45,$51,$55
;	.db	                            $57
;	.db	$75,$55,$57,$75,$55,$57,$75,$55
;	.db	$57,$75,$55,$54,$45,$55,$54,$45
;	.db	$55,$54,$45,$55,$54,$45,$55
;	.db	                            $15
;	.db	$15,$15,$15,$15,$15,$15,$15,$15
;	.db	$15

	;`g
;	.db	$ff,$ff,$ff,$ff,$ff,$ff,$00,$00
;	.db	$00,$00,$00,$00
;	.db	                $ff,$ff,$ff,$ff
;	.db	$ff,$55,$55,$00,$00,$00,$00,$00
;	.db	$55,$55
;	.db	        $ff,$ff,$ff,$ff,$55,$55
;	.db	$55,$55,$05,$00,$00,$00,$50,$55
;	.db	$55,$55,$55
;	.db	            $ff,$ff,$ff,$55,$55
;	.db	$55,$55,$55,$55,$55,$00,$00,$00
;	.db	$55,$55,$55,$55,$55,$55,$55
;	.db	                            $ff
;	.db	$ff,$55,$55,$55,$55,$55,$55,$55
;	.db	$55,$55,$55,$00,$00,$55,$55,$55
;	.db	$55,$55,$55,$55,$55,$55,$55
;	.db	                            $15
;	.db	$15,$15,$15,$15,$15,$15,$15,$15
;	.db	$15
Fssql_Dpcm_End:

Fssql_VolTable:
	.db	$00,$00,$00,$00
	.db	$00,$01,$02,$03,$04,$05,$06,$07
	.db	$08,$09,$0a,$0b,$0c,$0d,$0e,$0f
	.db	$0f,$0f,$0f,$0f

Fssql_FirstCH:
;	.db	0, 4
Fssql_ToReflect:
	.db	 0,  4,  8, 12,  1,  5,  9, 13

Fssql_SetRegBit:
	.db	$30,$30,$ff,$30,$08,$08

Fssql_ToCtrl:
	.db	$00, $00, $20, $40

Fssql_Tick:
	.db	$fe, $03

Fssql_Apu_KeyTable_L:
	; o1
	.db	LOW(3420), LOW(3229), LOW(3047), LOW(2876)
	.db	LOW(2715), LOW(2562), LOW(2419), LOW(2283)
	.db	LOW(2155), LOW(2034), LOW(1920), LOW(1812)

Fssql_Apu_KeyTable_H:
	; o1
	.db	HIGH(3420), HIGH(3229), HIGH(3047), HIGH(2876)
	.db	HIGH(2715), HIGH(2562), HIGH(2419), HIGH(2283)
	.db	HIGH(2155), HIGH(2034), HIGH(1920), HIGH(1812)

Fssql_DrumKey:
	.db	9	; Bass
	.db	12	; Snare
	.db	14	; Drum

	; TEhhCo
	; use reg: a x
	; use work: none
Fssql_Init:
	lda	#$c0
	sta	$4017	; disable frame interrupt
	lda	#$00
	sta	$4011

;	lda	#$00
	ldx	#$14-1
.1:
	sta	<$bc,x
	dex
	bpl	.1

;	lda	#$00
	ldx	#(FSSQL_KEYON-FSSQL_LENTBL_L-1)
.2:
	sta	FSSQL_LENTBL_L,x
	dex
	bpl	.2

	txa	; lda	#$ff
	ldx	#FSSQL_TRACK_SIZE
.3:
	sta	FSSQL_CH,x
	dex
	bpl	.3

;	ldx	#$ff
	stx	$4008
	lda	#150
	sta	FSSQL_TEMPO

	rts

	; TEhhCo[BGMt
	; a: p[^̃AhX(LOW)
	; x: p[^̃AhX(HIGH)
	; use reg: a x y
	; use work: 0-3
	; use arg: 0-7
Fssql_PlayBGM:
	jsr	Fssql_TransArgBGM
	sta	<FSSQL_STAT

	lda	#$00
	sta	FSSQL_TCNT
	sta	FSSQL_FADEOUT
	sta	FSSQL_LOOP_CNT
	ldx	#3
.1:
	sta	FSSQL_S_SEQ_H,x
	dex
	bpl	.1

	ldx	#3
	ldy	#3
	bne	_Fssql_Play	; same as jmp

	; TEhhCo[SEt
	; a: p[^̃AhX(LOW)
	; x: p[^̃AhX(HIGH)
	; use reg: a x y
	; use work: 0-3
	; use arg: 0-7
Fssql_PlaySE:
	jsr	Fssql_TransArgSE
	sta	<FNC_WORK
	lda	<FSSQL_STAT+1
;	and	#$fb	; Opg(h)O
	beq	.1
	jsr	Fssql_StopSE
.1:
	lda	<FNC_WORK
	sta	<FSSQL_STAT+1

	ldx	#4
	ldy	#0
	tya
_Fssql_Play:
	sta	FSSQL_LCNT,x
	sta	FSSQL_REG2,x
	sta	<FSSQL_NCNT,x
	sta	FSSQL_KEYON,x
	dex
	dey
	bpl	_Fssql_Play
	rts

Fssql_TransArgSE:
	.db	$24	; bit <$b8
Fssql_TransArgBGM:
	clv
	sta	<FNC_WORK
	stx	<FNC_WORK+1

	; `ltO擾
	ldy	#0
	lda	[FNC_WORK],y
	and	#$0f
	beq	.9
	sta	<FNC_WORK+2

	bvs	.3

	; TRCHϊe[u쐬(BGM)
	sta	<FNC_WORK+3
	ldx	#0
.1:
	txa
	lsr	<FNC_WORK+3
	bcs	.2
	lda	#$ff
.2:
	sta	FSSQL_CH,x
	inx
	cpx	#4
	bne	.1

	; e|l擾(BGM)
	ldy	#1
	lda	[FNC_WORK],y
	sta	FSSQL_TEMPO

	ldx	#0
	beq	.5	; same as jmp

.3:
	; TRCHϊe[u쐬(SE)
	ldx	#$ff
.4:
	inx
	lsr	a
	bcc	.4
	stx	FSSQL_CH+4
	ldx	#1

.5:
	; e[ũAhX̓]
	ldy	#2
.6:
	lda	[FNC_WORK],y
	iny
	sta	FSSQL_LENTBL_L,x
	inx
	inx
	cpx	#4
	bcc	.6

	; V[PXf[^̃AhX̓]
	lda	Fssql_FirstCH-4,x
	tax
.7:
	lda	FSSQL_CH,x
	bmi	.8
	stx	<FNC_WORK+3
	tax
	lda	[FNC_WORK],y
	iny
	sta	FSSQL_SEQ_L,x
	lda	[FNC_WORK],y
	iny
	sta	FSSQL_SEQ_H,x
	ldx	<FNC_WORK+3
.8:
	inx
	cpx	#4
	bcc	.7

	lda	<FNC_WORK+2
.9:
	rts

	; TEhhCo[ tF[hAEg
	; use reg: a
Fssql_Fadeout:
	lda	#$80
	sta	FSSQL_FADEOUT
	rts

	; TEhhCo[BGMtĊJ
	; use reg: a
Fssql_ResumeBGM:
	lda	FSSQL_PAUSE
	sta	<FSSQL_STAT
	sta	<FSSQL_STAT+2
	rts

	; TEhhCo[BGMtꎞ~
	; use reg: a
Fssql_PauseBGM:
	lda	<FSSQL_STAT
	sta	FSSQL_PAUSE
;	jmp	Fssql_StopBGM

	; TEhhCo[BGMt~
	; use reg: a
Fssql_StopBGM:
	lda	#$00
	sta	<FSSQL_STAT
	sta	<FSSQL_STAT+2
	lda	#$ff
	ldy	#3
.1:
	sta	FSSQL_CH,y
	dey
	bpl	.1
	rts

	; TEhhCo[SEt~
	; use reg: a x y
Fssql_StopSE:
	ldx	FSSQL_CH+4
	lda	#$ff
	sta	FSSQL_CH+4
	eor	Bit,x
	and	<FSSQL_STAT+1
	sta	<FSSQL_STAT+1
	and	<FSSQL_STAT+3
	sta	<FSSQL_STAT+3

	ldy	FSSQL_CH,x
	bmi	.3

	cpy	#2
	beq	.2	; Opg̓WX^߂Ȃ
	lda	<FSSQL_REF
	ora	Bit,x
	bcs	.1
	ora	Bit+4,x	; `ĝ
.1:
	sta	<FSSQL_REF

	lda	FSSQL_REG1,y
	sta	FSSQL_TREG1,x
	bcs	.2
	lda	FSSQL_REG2,y	; `ĝ
	sta	FSSQL_TREG1+4,x
	asl	a		; `g̃XC[vL
	bcs	.3
.2:
	lda	FSSQL_KEYON,y
	and	#$0f
	cmp	#2
	bcc	.3

	cpx	#3
	bcs	.3	; mCY͏O

;	clc
	adc	FSSQL_TBASE,y

	jsr	_Fssql_GetFreq
	sta	<FSSQL_TREG2+4,x
	lda	<_FSSQL_WORK
	sta	<FSSQL_TREG2,x

	lda	<FSSQL_REF+1
	ora	Bit,x
	ora	Bit+4,x
	sta	<FSSQL_REF+1
.3:
	rts

_Fssql_GetFreq:
	stx	<_FSSQL_WORK
	ldx	#1
.1:
	cmp	#12+2
	bcc	.2
;	sec
	sbc	#12
	inx
	bne	.1		; same as jmp
.2:
	tay
	lda	Fssql_Apu_KeyTable_H-2,y
	sta	<_FSSQL_WORK+1
	lda	Fssql_Apu_KeyTable_L-2,y
.3:
	lsr	<_FSSQL_WORK+1
	ror	a
	dex
	bne	.3
	ldx	<_FSSQL_WORK
	sta	<_FSSQL_WORK
	lda	FSSQL_ENV,x
	and	#$03
	clc
	adc	<_FSSQL_WORK
	sta	<_FSSQL_WORK
	lda	<_FSSQL_WORK+1
	adc	#0
	ora	#$08
	rts

	; TEhhCoXV
	; use reg: a x y
	; use work: 0-11
	; use arg: 0-3
Fssql_Update:
	; CfbNX̏
	ldy	#0
	sty	<_FSSQL_TR_INX
	beq	.main1	; same as jmp
.main20:
	ldy	#1
.main1:
	sty	<_FSSQL_CCTRL

	lda	FSSQL_LENTBL_L,y
	sta	<_FSSQL_LENTBL
	lda	FSSQL_LENTBL_H,y
	sta	<_FSSQL_LENTBL+1

	ldx	Fssql_Tick,y
	bpl	.main8

	; TickZo
	lda	FSSQL_TEMPO
;	ldx	#$fe
	sec
.main6:
	inx
	sbc	#75
	bcs	.main6
;	clc
	adc	#75

	clc
	adc	FSSQL_TCNT
	sec
.main7:
	inx
	sbc	#75
	bcs	.main7
;	clc
	adc	#75
	sta	FSSQL_TCNT
.main8:
	stx	<_FSSQL_TICK

.main10:
	; V[PX
	ldx	<_FSSQL_TR_INX
	ldy	FSSQL_CH,x
	bmi	.main17

	sty	<_FSSQL_CH_INX
	lda	Bit,y
	sta	<_FSSQL_CH_BIT
	and	<FSSQL_STAT
	and	<FSSQL_STAT+1
	cmp	#$01
	lda	<_FSSQL_CCTRL
	bne	.main13
	ror	a
.main13:
	ora	Fssql_ToCtrl,y
	sta	<_FSSQL_CCTRL

	lda	<FSSQL_NCNT,x
	cmp	#$10
	bcs	.main15
	jsr	.sequence
.main15:
	jsr	.envelope

	ldx	<_FSSQL_TR_INX
	lda	<FSSQL_NCNT,x
	clc
	adc	<_FSSQL_TICK
	sta	<FSSQL_NCNT,x
.main17:
	; CfbNX̍XV
	inx
	stx	<_FSSQL_TR_INX
	cpx	#FSSQL_BGM_TRACK_SIZE
	beq	.main20
;	cpx	#FSSQL_TRACK_SIZE
;	bne	.main10
	bcc	.main10

	; tF[hAEgJE^XV
	ldy	FSSQL_FADEOUT
;	beq	.main19
	beq	.len3
	lda	<SYS_CNT
	and	#$07
;	bne	.main19
	bne	.len3
	lda	Int-$10,y
	sta	FSSQL_FADEOUT
;	bne	.main19
	bne	.len3
	jmp	Fssql_StopBGM
;.main19:
;	rts

.lentbl:
	sta	FSSQL_KEYON,x
	sty	<_FSSQL_WORK+2
	ldy	<_FSSQL_LENTBL+1
	lda	FSSQL_LBASE,x
	rol	a
	bcc	.len1
	iny
	clc
.len1:
	adc	<_FSSQL_LENTBL
	bcc	.len2
	iny
.len2:
	sta	<_FSSQL_WORK
	sty	<_FSSQL_WORK+1

	lda	<_FSSQL_WORK+2
	and	#$f0
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	[_FSSQL_WORK],y
	beq	.len3

;	clc
	adc	<FSSQL_NCNT,x
	sta	<FSSQL_NCNT,x
.len3:
	rts

	; WX^1ݒR}h
.cmd_reg1:
;	ldx	<_FSSQL_TR_INX

	lda	[_FSSQL_SEQ],y
.cmd_reg1_1:
	ldy	<_FSSQL_CH_INX

	bcs	.cmd_reg2

	cpy	#2
	beq	.cmd_reg2_2	; Opg͐ݒ肵Ȃ

	sta	FSSQL_REG1,x

	bit	<_FSSQL_CCTRL
	bmi	.cmd_reg2_2

	sta	FSSQL_TREG1,y
	lda	<_FSSQL_CH_BIT
	bne	.cmd_reg2_1	; same as jmp

	; WX^2ݒR}h
.cmd_reg2:
	sta	FSSQL_REG2,x

	ldx	<_FSSQL_CCTRL
	cpx	#$20
	bcs	.cmd_reg2_2

	sta	FSSQL_TREG1+4,y
	ldx	<_FSSQL_TR_INX
	lda	Bit+4,y
.cmd_reg2_1:
	ora	<FSSQL_REF
	sta	<FSSQL_REF
.cmd_reg2_2:
	ldy	#2
	bne	.seq_next	; same as jmp

	; x[XݒR}h
.cmd_tbase:
;	ldx	<_FSSQL_TR_INX

	lda	[_FSSQL_SEQ],y

	bcs	.cmd_lbase

	sta	FSSQL_TBASE,x
	bcc	.seq_next1	; same as jmp

	; x[XݒR}h
.cmd_lbase:
	sta	FSSQL_LBASE,x
	bcs	.seq_next1	; same as jmp

	; Gx[vݒR}h
.cmd_env:
	bcs	.seq_next

;	ldx	<_FSSQL_TR_INX

	lda	[_FSSQL_SEQ],y

	sta	FSSQL_ENV,x
	bcc	.seq_next1	; same as jmp

	; e|ݒR}h
.cmd_tempo:
	bcs	.cmd_loop_cnt

;	ldx	<_FSSQL_TR_INX
	cpx	#FSSQL_BGM_TRACK_SIZE
	bcs	.seq_next1

	lda	[_FSSQL_SEQ],y
	sta	FSSQL_TEMPO
	bcc	.seq_next1	; same as jmp

	; [vJE^R}h
.cmd_loop_cnt:
	inc	FSSQL_LOOP_CNT
	bcs	.seq_next	; same as jmp

	; /x/R}h̏(KeyOff)
.note_off:
	clc
	lda	#$00
	jsr	.lentbl
	beq	.off5

	lda	#$20
	bit	<_FSSQL_CCTRL
	bmi	.off4
	bne	.off3
	lda	FSSQL_REG1,x
	and	#$10
	bne	.off4

	; ̏
.off2:
	ldy	<_FSSQL_CH_INX
	lda	FSSQL_TREG1,y
	and	#$f0
	sta	FSSQL_TREG1,y
.off3:
	jsr	.mute
.off4:
	jmp	.end0
.off5:
	lda	<_FSSQL_WORK+2
	sta	FSSQL_KEYON,x
	jmp	.seq

.sequence:
	; V[PX|C^[N̈ɃRs[
	lda	FSSQL_SEQ_L,x
	sta	<_FSSQL_SEQ
	lda	FSSQL_SEQ_H,x
	sta	<_FSSQL_SEQ+1

	; /x/R}hKeyOff
	ldy	FSSQL_KEYON,x
	bne	.note_off
	beq	.seq	; same as jmp

.seq_next1:
	iny
.seq_next:
	; V[PX|C^i߂
	tya
	clc
	adc	<_FSSQL_SEQ
	sta	<_FSSQL_SEQ
	bcc	.seq
	inc	<_FSSQL_SEQ+1
.seq:
	; V[PXR}hǂ
	ldy	#0
	lda	[_FSSQL_SEQ],y

	; /x/R}h̔
	cmp	#$10
	bcs	.note_on

	; R}h̕
	lsr	a
	tay
	lda	.jmptbl_h,y
	pha
	lda	.jmptbl_l,y
	pha
	ldy	#1
	rts

	; /x/R}h̏(KeyOn)
.note_on:
	ldx	<_FSSQL_TR_INX

	tay
	bit	Int+$0f
	bne	.note_on1
	eor	FSSQL_KEYON,x
	and	#$f0
	eor	FSSQL_KEYON,x
.note_on1:
	jsr	.lentbl

	lda	<_FSSQL_WORK+2
	and	#$0f
	beq	.on_extend
	cmp	#$01
	bne	.on_note

.on_rest:
	; x̏
	jsr	.mute

	lda	<_FSSQL_CCTRL
	and	#$a0
	bne	.on_extend

	; `g,mCY
	ldy	<_FSSQL_CH_INX
	lda	FSSQL_TREG1,y
	and	#$f0
	sta	FSSQL_TREG1,y
.on_extend:
	jmp	.end1

.on_note:
	; ̏
	clc
	adc	FSSQL_TBASE,x

.key_on:
	; L[I
	ldy	FSSQL_REG1,x
	sty	<_FSSQL_WORK+2
	bit	<_FSSQL_CCTRL
	bvs	.keyon4

	; `g,Opg
	jsr	_Fssql_GetFreq
	bne	.keyon10	; same as jmp

	; mCY
.keyon4:
	sec
	sbc	#$22
	bcs	.keyon6

	; mCYgw
;	clc
	adc	#$10
	and	#$8f
	jmp	.keyon9
.keyon5:
	beq	.on_rest	; same as jmp
.keyon6:
	; Yw
;	sec
	adc	#1
	tay
	lda	[_FSSQL_LENTBL],y
	sta	<_FSSQL_WORK
	and	#$0c
	beq	.keyon7

	lsr	a
	lsr	a
	tay

	lda	Fssql_DrumKey-1,y
	sta	$4010
	lda	#((Fssql_Dpcm-$c000)/64)
	sta	$4012
	lda	#((Fssql_Dpcm_End-Fssql_Dpcm-1)/16)
	sta	$4013
	lda	#$10
	sta	<FSSQL_DMC

.keyon7:
	ldy	<_FSSQL_WORK
	lda	Xcn,y
	and	#$0f
	beq	.keyon5

	ora	#$30
	sta	<_FSSQL_WORK+2
	and	#$f0
	sta	FSSQL_REG1,x

	tya
	and	#$03
	cmp	#$02
	bcc	.keyon9
	ora	#$04
.keyon9:
	sta	<_FSSQL_WORK
	lda	#$08

.keyon10:
	bit	<_FSSQL_CCTRL
	bmi	.keyon16

	ldy	<_FSSQL_CH_INX
	sta	FSSQL_TREG2+4,y
	lda	<_FSSQL_WORK
	sta	FSSQL_TREG2,y

	lda	<FSSQL_REF+1
	ora	<_FSSQL_CH_BIT
	ora	Bit+4,y
	sta	<FSSQL_REF+1

	lda	<_FSSQL_CCTRL
	and	#$20
	bne	.keyon15

	; `g,mCY
	lda	<_FSSQL_WORK+2
	bit	Int+$20
	beq	.keyon14

	and	#$f0
	sta	<_FSSQL_WORK
	eor	<_FSSQL_WORK+2
	tay
	lda	FSSQL_ENV,x
	and	#$0c
	clc
	adc	Int,y
	tay
	lda	Fssql_VolTable,y
	ora	<_FSSQL_WORK

	ldy	<_FSSQL_CH_INX
.keyon14:
	sta	FSSQL_TREG1,y

	lda	<FSSQL_REF
	ora	<_FSSQL_CH_BIT
	sta	<FSSQL_REF

.keyon15:
	lda	<_FSSQL_CCTRL
	and	#$01
	tax
	lda	<FSSQL_STAT+2,x
	ora	<_FSSQL_CH_BIT
	sta	<FSSQL_STAT+2,x
.keyon16:
	jmp	.end1

.jmptbl_l:
	.db	LOW(.cmd_term-1),   LOW(.cmd_call-1)
	.db	LOW(.cmd_repeat-1), LOW(.cmd_rep_wide-1)
	.db	LOW(.cmd_reg1-1),   LOW(.cmd_tbase-1)
	.db	LOW(.cmd_env-1),    LOW(.cmd_tempo-1)
.jmptbl_h:
	.db	HIGH(.cmd_term-1),   HIGH(.cmd_call-1)
	.db	HIGH(.cmd_repeat-1), HIGH(.cmd_rep_wide-1)
	.db	HIGH(.cmd_reg1-1),   HIGH(.cmd_tbase-1)
	.db	HIGH(.cmd_env-1),    HIGH(.cmd_tempo-1)

	; L惊s[gR}h
.cmd_rep_wide:
;	ldx	<_FSSQL_TR_INX
	lda	Int+(FSSQL_REG2-FSSQL_LCNT),x
	tax

	; s[gR}h
.cmd_repeat:
;	ldx	<_FSSQL_TR_INX

	lda	[_FSSQL_SEQ],y

	bcs	.cmd_rep5

	; V[g`
.cmd_rep1:
	sta	<_FSSQL_WORK
	ora	#$e0
	sta	<_FSSQL_WORK+1

	; [vJE^mF
	; 0:[v 0ȊO:[v
	lda	FSSQL_LCNT,x
	bne	.cmd_rep3

	; [v̏
	lda	<_FSSQL_WORK
;	clc
	adc	#$40
	ror	a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
.cmd_rep2:
	sta	FSSQL_LCNT,x

.cmd_rep3:
	dec	FSSQL_LCNT,x
	beq	.cmd_rep4

	; V[PX|C^ɔѐ܂ł̋Z
	lda	<_FSSQL_WORK+1
	clc
	adc	<_FSSQL_SEQ
	sta	<_FSSQL_SEQ
	bcs	.cmd_rep4
	dec	<_FSSQL_SEQ+1
.cmd_rep4:
	ldx	<_FSSQL_TR_INX
	jmp	.seq_next1

	; O`
.cmd_rep5:
	sta	<_FSSQL_WORK
	iny
	lda	[_FSSQL_SEQ],y
	sta	<_FSSQL_WORK+1

	; [vJE^mF
	; 0:[v 0ȊO:[v
	lda	FSSQL_LCNT,x
	bne	.cmd_rep3

	lda	<_FSSQL_WORK
	bcs	.cmd_rep2	; same as jmp


	; Tu[`R}h
.cmd_call:
	bcs	.cmd_jmp

;	ldx	<_FSSQL_TR_INX

	lda	[_FSSQL_SEQ],y
	asl	a
	lda	<_FSSQL_SEQ
	adc	#0
	sta	FSSQL_S_SEQ_L,x
	lda	<_FSSQL_SEQ+1
	adc	#0
	sta	FSSQL_S_SEQ_H,x
	lda	FSSQL_TBASE,x
	sta	FSSQL_S_TBASE,x
	lda	FSSQL_LBASE,x
	sta	FSSQL_S_LBASE,x

	; WvR}h
.cmd_jmp:
	lda	[_FSSQL_SEQ],y

	asl	a
	bcs	.cmd_jmp2

	; V[g`
	cmp	#$80
	ror	a
	sta	<_FSSQL_WORK
	ora	#$7f
	bmi	.cmd_jmp1
	lda	#$00
.cmd_jmp1:
	bcc	.cmd_jmp3	; same as jmp

	; O`
.cmd_jmp2:
	sta	<_FSSQL_WORK

	iny
	lda	[_FSSQL_SEQ],y
	cmp	#$80
	ror	a
	ror	<_FSSQL_WORK

.cmd_jmp3:
	sta	<_FSSQL_WORK+1

	; V[PX|C^ɔѐ܂ł̋Z
	lda	<_FSSQL_SEQ
;	clc
	adc	<_FSSQL_WORK
	sta	<_FSSQL_SEQ
	lda	<_FSSQL_SEQ+1
	adc	<_FSSQL_WORK+1
	sta	<_FSSQL_SEQ+1
	jmp	.seq_next1

	; Tu[`A
.cmd_ret:
;	ldx	<_FSSQL_TR_INX

	lda	FSSQL_S_SEQ_H,x
	beq	.cmd_ret1

	sta	<_FSSQL_SEQ+1
	lda	FSSQL_S_SEQ_L,x
	sta	<_FSSQL_SEQ
	lda	FSSQL_S_TBASE,x
	sta	FSSQL_TBASE,x
	lda	FSSQL_S_LBASE,x
	sta	FSSQL_LBASE,x
	lda	#0
	sta	FSSQL_S_SEQ_H,x
	ldy	#2
.cmd_ret1:
	jmp	.seq_next

	; V[PX̏I[
.cmd_term:
	bcs	.cmd_ret

	lda	<_FSSQL_CH_BIT
	eor	#$ff
	tay

	cpx	#FSSQL_BGM_TRACK_SIZE
	bcs	.cmd_term1

	; BGM
	and	<FSSQL_STAT
	sta	<FSSQL_STAT

	tya
	and	<FSSQL_STAT+2
	sta	<FSSQL_STAT+2
	bcc	.end0	; same as jmp

	; SE
.cmd_term1:
	jsr	Fssql_StopSE
;	jmp	.end0

.end0:
	clc
	.db	$a9	; lda #$38
.end1:
	sec
	; V[PX|C^̏߂
	ldx	<_FSSQL_TR_INX
	lda	<_FSSQL_SEQ
	adc	#0
	sta	FSSQL_SEQ_L,x
	lda	<_FSSQL_SEQ+1
	adc	#0
	sta	FSSQL_SEQ_H,x
	rts

	; Gx[v
.envelope:
;	ldx	<_FSSQL_TR_INX

	; 
	lda	#$20
	bit	<_FSSQL_CCTRL
	bmi	.env1
	beq	.env2

	; Opg
	lda	FSSQL_FADEOUT
	beq	.env1
.mute:
	; ̏
	lda	<_FSSQL_CCTRL
	and	#$01
	tax
	lda	<_FSSQL_CH_BIT
	eor	#$ff
	and	<FSSQL_STAT+2,x
	sta	<FSSQL_STAT+2,x
.env1:
	rts

.env2:
	; `g,mCY
	ldy	<_FSSQL_CH_INX
	lda	FSSQL_TREG1,y

	ldy	FSSQL_FADEOUT
	bne	.env3
	ldy	FSSQL_KEYON,x
	bne	.env4
.env3:
	bit	Int+$0f
	beq	.env1
	sec
	sbc	#1
	bcs	.env8	; same as jmp

.env4:
	and	#$0f
	tay
	lda	FSSQL_REG1,x
	and	#$f0
	sta	<_FSSQL_WORK
	eor	FSSQL_REG1,x
	cmp	Int,y
	beq	.env9
	bcc	.env5
	iny
	bcs	.env6
.env5:
	dey
.env6:
	cmp	Int,y
	beq	.env7
	lda	FSSQL_ENV,x
.env7:
	and	#$c0
	eor	<_FSSQL_WORK
	ora	Int,y
.env8:
	ldy	<_FSSQL_CH_INX
	sta	FSSQL_TREG1,y
.env9:
	and	#$0f
	beq	.mute

	; 
	lda	<FSSQL_REF
	ora	<_FSSQL_CH_BIT
	sta	<FSSQL_REF
	rts

Fssql_Reflect:
	; Đ`l̐ݒ(WX^ݒ)
	lda	$4015
	and	#$10
	pha
	eor	<FSSQL_DMC
	ora	<FSSQL_STAT
	ora	<FSSQL_STAT+1
	sta	$4015

	; APUWX^ւ̔f
	ldx	#0
	beq	.5	; same as jmp
.1:
	cpx	#4
	lda	FSSQL_TREG1,x
	bcc	.2
	bmi	.3
.2:
	ora	Fssql_SetRegBit,x
.3:
	ldy	Fssql_ToReflect,x
	sta	$4000,y
.4:
	inx
.5:
	lsr	<FSSQL_REF
	bcs	.1
	bne	.4

	ldx	#0
	beq	.8	; same as jmp
.6:
	lda	<FSSQL_TREG2,x
	ldy	Fssql_ToReflect,x
	sta	$4002,y
.7:
	inx
.8:
	lsr	<FSSQL_REF+1
	bcs	.6
	bne	.7

	; Đ`l̐ݒ(x)
	pla
	ora	<FSSQL_DMC
	ora	<FSSQL_STAT+2
	ora	<FSSQL_STAT+3
	sta	$4015
	lda	#0
	sta	<FSSQL_DMC

	rts

