; [U^XN(C)

	; 
User:
	; XN[It
	lda	#$00
	sta	$2001

	; ~[O
	lda	#$01	; ~[O
	sta	$a000

	; pbg
	ldx	#PS_BG_PLAYER
	jsr	Pal_SetBGPalette
	ldx	#PS_SP_PLAYER
	jsr	Pal_SetSPPalette
	lda	#$40
	jsr	Vcmd_SetPalette

	; XN[ݒ
	lda	#$00
	sta	<SCROLL_X
	sta	<SCROLL_Y

	; NMI^XNݒ
	lda	#LOW(User_Nmi)
	sta	NMI_FNC
	lda	#HIGH(User_Nmi)
	sta	NMI_FNC+1

	; jmpߐݒ
	lda	#$6c
	sta	<USR_FNC-1

	; ϐ

	; XvCg
;	jsr	Spr_Init

	jsr	Yeild_SetEntry	; t[͂

	; ʏ
	lda	#LOW(Vcmd_Clear)
	ldx	#HIGH(Vcmd_Clear)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; XN[I
	lda	#$80
	sta	<PPU_REG1
	sta	$2000
	lda	#$1e
	sta	$2001

	jsr	Yeild		; t[܂őҋ@

Player_Init:
	; vC[ʕ`
	lda	#LOW(Vcmd_KeyBoard)
	ldx	#HIGH(Vcmd_KeyBoard)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	jsr	FadeIn

	ldy	#0
	sty	<PLAY_STATE
	sty	<BGM_NUM
	jsr	PlayBGM

Player_Main:
	jsr	Yeild_SetEntry

	jsr	UpdateKeyPos
	jsr	Spr_Key

	lda	<PLAY_STATE
	cmp	#0
	bne	.1

	lda	FSSQL_LOOP_CNT
	cmp	#2
	bcc	.9
	lda	#1
	sta	<PLAY_STATE
	lda	#180
	sta	<PLAY_CNT
	jmp	.9
.1:
	cmp	#1
	bne	.2

	dec	<PLAY_CNT
	bne	.9
	jsr	Fssql_Fadeout
	lda	#2
	sta	<PLAY_STATE
	lda	#80
	sta	<PLAY_CNT
	jmp	.9
.2:
	dec	<PLAY_CNT
	bne	.9
	lda	#0
	sta	<PLAY_STATE
	sta	<PLAY_CNT
	ldy	<BGM_NUM
	iny
	cpy	#(PlayBGM_H-PlayBGM_L)
	bcc	.3
	ldy	#0
.3:
	sty	<BGM_NUM
	jsr	PlayBGM
.9:

	lda	<JOYPAD
	eor	<JOYPAD_PREV
	and	#JOY_A
	beq	.10

	lda	#1
	sta	<PLAY_STATE
	sta	<PLAY_CNT
.10:
	lda	<JOYPAD
	sta	JOYPAD_PREV

	jsr	Yeild_ReEntry

PlayBGM:
	lda	PlayBGM_L,y
	ldx	PlayBGM_H,y
	jmp	Fssql_PlayBGM
PlayBGM_L:
	.db	LOW(Bgm03_PlayData)
	.db	LOW(Bgm15_PlayData)
	.db	LOW(Bgm20_PlayData)
PlayBGM_H:
	.db	HIGH(Bgm03_PlayData)
	.db	HIGH(Bgm15_PlayData)
	.db	HIGH(Bgm20_PlayData)

UpdateKeyPos:
	lda	<FSSQL_STAT+2
	ora	<FSSQL_STAT+3
	sta	<FNC_WORK+2

	ldy	#$ff
	lda	#$08
	bit	<FNC_WORK+2
	beq	.1
	lda	<FSSQL_TREG2+3
	jsr	Noise2Key
	tay
.1:
	sty	<KEY_POS+3

	ldx	#2
.2:
	ldy	#$ff
	lda	Bit,x
	bit	<FNC_WORK+2
	beq	.3
	ldy	<FSSQL_TREG2,x
	lda	<FSSQL_TREG2+4,x
	and	#$07
	jsr	Tone2Key
.3:
	sty	<KEY_POS,x

	dex
	bpl	.2

	rts

Tone2Key:
	sty	<FNC_WORK
	sta	<FNC_WORK+1
	ldy	#(.key_h-.key_l-1)
.1:
	lda	<FNC_WORK+1
	cmp	.key_h,y
	bcc	.3
	bne	.2
	lda	<FNC_WORK
	cmp	.key_l,y
	bcc	.3
.2:
	dey
	bpl	.1
.3:
	rts
.key_l:
	.db	LOW(1761), LOW(1662), LOW(1569), LOW(1481)
	.db	LOW(1398), LOW(1319), LOW(1245), LOW(1175)
	.db	LOW(1109), LOW(1047), LOW( 988), LOW( 933)
	.db	LOW( 881), LOW( 831), LOW( 784), LOW( 740)
	.db	LOW( 699), LOW( 660), LOW( 623), LOW( 588)
	.db	LOW( 555), LOW( 524), LOW( 494), LOW( 466)
	.db	LOW( 440), LOW( 416), LOW( 392), LOW( 370)
	.db	LOW( 349), LOW( 330), LOW( 311), LOW( 294)
	.db	LOW( 277), LOW( 262), LOW( 247), LOW( 233)
	.db	LOW( 220), LOW( 208), LOW( 196), LOW( 185)
	.db	LOW( 175), LOW( 165), LOW( 156), LOW( 147)
	.db	LOW( 139), LOW( 131), LOW( 124), LOW( 117)
	.db	LOW( 110), LOW( 104), LOW(  98), LOW(  93)
	.db	LOW(  87), LOW(  82), LOW(  78), LOW(  73)
	.db	LOW(  69), LOW(  65), LOW(  62), LOW(  58)
	.db	LOW(  55), LOW(  52), LOW(  49), LOW(  46)
	.db	LOW(  44), LOW(  41), LOW(  39), LOW(  37)
	.db	LOW(  35), LOW(  33), LOW(  31), LOW(  29)
.key_h:
	.db	HIGH(1761), HIGH(1662), HIGH(1569), HIGH(1481)
	.db	HIGH(1398), HIGH(1319), HIGH(1245), HIGH(1175)
	.db	HIGH(1109), HIGH(1047), HIGH( 988), HIGH( 933)
	.db	HIGH( 881), HIGH( 831), HIGH( 784), HIGH( 740)
	.db	HIGH( 699), HIGH( 660), HIGH( 623), HIGH( 588)
	.db	HIGH( 555), HIGH( 524), HIGH( 494), HIGH( 466)
	.db	HIGH( 440), HIGH( 416), HIGH( 392), HIGH( 370)
	.db	HIGH( 349), HIGH( 330), HIGH( 311), HIGH( 294)
	.db	HIGH( 277), HIGH( 262), HIGH( 247), HIGH( 233)
	.db	HIGH( 220), HIGH( 208), HIGH( 196), HIGH( 185)
	.db	HIGH( 175), HIGH( 165), HIGH( 156), HIGH( 147)
	.db	HIGH( 139), HIGH( 131), HIGH( 124), HIGH( 117)
	.db	HIGH( 110), HIGH( 104), HIGH(  98), HIGH(  93)
	.db	HIGH(  87), HIGH(  82), HIGH(  78), HIGH(  73)
	.db	HIGH(  69), HIGH(  65), HIGH(  62), HIGH(  58)
	.db	HIGH(  55), HIGH(  52), HIGH(  49), HIGH(  46)
	.db	HIGH(  44), HIGH(  41), HIGH(  39), HIGH(  37)
	.db	HIGH(  35), HIGH(  33), HIGH(  31), HIGH(  29)

Noise2Key:
	and	#$8f
	bpl	.1
	ora	#$70
.1:
	clc
	adc	#$10
	rts


FadeIn:
	lda	#$07
	sta	<USR_CNT
	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT
	asl	a
	asl	a
	asl	a
	and	#$f0
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	bne	.1
	jmp	Yeild		; t[܂őҋ@
.1:
	jmp	_ReEntry

FadeOut:
	lda	#$01
	sta	<USR_CNT
	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT
	asl	a
	asl	a
	asl	a
	and	#$f0
	jsr	Vcmd_SetPalette

	inc	<USR_CNT
	lda	<USR_CNT
	cmp	#$09
	bne	.1
	jmp	Yeild		; t[܂őҋ@
.1:
	jmp	_ReEntry

User_Nmi:
	lda	<PPU_REG1
	and	#$fe
	sta	<PPU_REG1

	lda	$2002	; clear address latch

	rts

; pbg֌W

	; x : 0000nnnn n:scene num
	; use reg : a x y
Pal_SetBGPalette:
	lda	Xcn,x
	ora	#$0f
	tax
	ldy	#15
.1:
	lda	Pal_Data_Frame,x
	sta	PAL_BGBUF,y
	dex
	dey
	bpl	.1
	rts

	; x : 0000nnnn n:scene num
	; use reg : a x y
Pal_SetSPPalette:
	lda	Xcn,x
	ora	#$0f
	tax
	ldy	#15
.1:
	lda	Pal_Data_Object,x
	sta	PAL_BGBUF+16,y
	dex
	dey
	bpl	.1
	rts

; XvCg֌W

Spr_Init:
	ldx	#$00
.1:
	lda	#240
	sta	SPR_DATA,x
	lda	Int+4,x
	tax
	bne	.1

	lda	#1
	sta	<SPR_UPD
	rts

Spr_Key:
	ldx	#$03
	ldy	#$00
.1:
	stx	<FNC_WORK+1
	lda	.ypos,x
	sta	SPR_DATA,y
	clc
	adc	#8
	sta	SPR_DATA+4,y

	lda	<KEY_POS,x
	bmi	.3
	ldx	#$ff
	sec
.2:
	inx
	sbc	#12
	bcs	.2
;	clc
	adc	#12
	stx	<FNC_WORK
	tax

	lda	.tile,x
	sta	SPR_DATA+1,y
	clc
	adc	#4
	sta	SPR_DATA+5,y

	lda	#$00
	sta	SPR_DATA+2,y
	sta	SPR_DATA+6,y
	beq	.4	; same as jmp
.3:
	lda	#240
	sta	SPR_DATA,y
	sta	SPR_DATA+4,y
.4:
	lda	.xpos1,x
	ldx	<FNC_WORK
	clc
	adc	.xpos2,x
	sta	SPR_DATA+3,y
	sta	SPR_DATA+7,y

	lda	Int+8,y
	tay
	ldx	<FNC_WORK+1
	dex
	bpl	.1

	ldx	#240
	lda	$4015
	and	#$10
	beq	.5
	ldx	#168-1
.5:
	stx	<FNC_WORK
	ldx	#4
.6:
	lda	<FNC_WORK
	sta	SPR_DATA,y
	lda	.tile3,x
	sta	SPR_DATA+1,y
	lda	#$00
	sta	SPR_DATA+2,y
	lda	.xpos3,x
	sta	SPR_DATA+3,y
	lda	Int+4,y
	tay
	dex
	bpl	.6

	lda	#1
	sta	<SPR_UPD
	rts
.xpos1:
	.db	0, 3, 4, 7, 8, 12, 15, 16, 19, 20, 23, 24
.xpos2:
	.db	48, 76, 104, 132, 160, 188
.ypos:
	.db	72-1, 96-1, 120-1, 144-1
.tile:
	.db	SP_KEY+0, SP_KEY+3, SP_KEY+1, SP_KEY+3
	.db	SP_KEY+2, SP_KEY+0, SP_KEY+3, SP_KEY+1
	.db	SP_KEY+3, SP_KEY+1, SP_KEY+3, SP_KEY+2

.xpos3:
	.db	112, 120, 128, 136, 144
.tile3:
	.db	SP_DCM+0, SP_DCM+1, SP_DCM+1, SP_DCM+1, SP_DCM+2

; Vcmd֌W

	; a : 0ddd0ttt d:darkness value 
	;     t:target (0:BG&SP 1:BG    2:SP       3:
	;               4:BG0   5:BG1-3 6:BG1-3&SP 7:)
	; use reg : a x y
	; use work : 0-1
Vcmd_SetPalette:
	and	#$77
	sta	<FNC_WORK
	and	#$07
	tax
	eor	<FNC_WORK
	sta	<FNC_WORK
	lda	.size,x
	sta	<FNC_WORK+1
	ldy	.offset,x
.1:
	lda	PAL_BGBUF,y
	sec
	sbc	<FNC_WORK
	bmi	.3
	cmp	#$0d
	bne	.4
.3:
	lda	#$1d
.4:
	sta	PAL_BGBUF2,y
	iny
	dec	<FNC_WORK+1
	bne	.1

	ldx	<VCMD_SIZE
	lda	#32
	sta	VCMD_DATA,x	; size
	lda	#$00
	sta	VCMD_DATA+1,x	; attr
	sta	VCMD_DATA+3,x	; ppu addr high
	lda	#$3f
	sta	VCMD_DATA+2,x	; ppu addr high
	lda	Int+36,x
	sta	<VCMD_SIZE
	tax

	ldy	#31
.5:
	dex
	lda	PAL_BGBUF2,y
	sta	VCMD_DATA,x
	dey
	bpl	.5

	rts
.offset:
	.db	 0,  0, 16,  0,  0,  4,  4,  0
.size:
	.db	32, 16, 16, 32,  4, 12, 28, 32

; f[^֌W

; pbg

Pal_Data_Frame:
	.db	$1d, $01, $11, $31	; player
	.db	$1d, $1d, $1d, $1d
	.db	$1d, $1d, $1d, $1d
	.db	$1d, $1d, $1d, $1d
Pal_Data_Object:
	.db	$1d, $1a, $2a, $3a	; player
	.db	$1d, $1d, $1d, $1d
	.db	$1d, $1d, $1d, $1d
	.db	$1d, $1d, $1d, $1d

; l[e[u

Clear_Data1:
	.db	VCX(0,1), BG_TILE, VCX(1,63)
Clear_Data1_End1:
	.db	VCX(1,64)
Clear_Data1_End2:
Clear_Data2:
	.db	VCX(0,1), $00, VCX(1,7)
Clear_Data2_End:
Vcmd_Clear:
	VCMD_SET	$00, $2380, Clear_Data1, Clear_Data1_End1
	VCMD_SET	$80, $23f8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2780, Clear_Data1, Clear_Data1_End1
	VCMD_SET	$80, $27f8, Clear_Data2, Clear_Data2_End

	VCMD_SET	$00, $2000, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23c0, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2080, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23c8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2100, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23d0, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2180, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23d8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2200, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23e0, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2280, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23e8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2300, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $23f0, Clear_Data2, Clear_Data2_End

	VCMD_SET	$00, $2400, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $27c0, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2480, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $27c8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2500, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $27d0, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2580, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $27d8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2600, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $27e0, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2680, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$80, $27e8, Clear_Data2, Clear_Data2_End
	VCMD_SET	$00, $2700, Clear_Data1, Clear_Data1_End2
	VCMD_SET	$c0, $27f0, Clear_Data2, Clear_Data2_End

KeyBoard_Data1:
	.db	VCX(0,22), BG_KB+0, BG_KB+1, BG_KB+2, BG_KB+1
	.db	           BG_KB+3, BG_KB+4, BG_KB+3
	.db                BG_KB+0, BG_KB+1, BG_KB+2, BG_KB+1
	.db	           BG_KB+3, BG_KB+4, BG_KB+3
	.db                BG_KB+0, BG_KB+1, BG_KB+2, BG_KB+1
	.db	           BG_KB+3, BG_KB+4, BG_KB+3, BG_KB+10
KeyBoard_Data1_End:
KeyBoard_Data2:
	.db	VCX(0,22), BG_KB+5, BG_KB+6, BG_KB+7, BG_KB+6
	.db	           BG_KB+8, BG_KB+9, BG_KB+8
	.db                BG_KB+5, BG_KB+6, BG_KB+7, BG_KB+6
	.db	           BG_KB+8, BG_KB+9, BG_KB+8
	.db                BG_KB+5, BG_KB+6, BG_KB+7, BG_KB+6
	.db	           BG_KB+8, BG_KB+9, BG_KB+8, BG_KB+10
KeyBoard_Data2_End:
KeyBoard_Data3:
	.db	VCX(0,5), BG_DCM+0, BG_DCM+1, BG_DCM+1, BG_DCM+1, BG_DCM+2
KeyBoard_Data3_End:
Vcmd_KeyBoard:
	VCMD_SET	$00, $2126, KeyBoard_Data1, KeyBoard_Data1_End
	VCMD_SET	$00, $2146, KeyBoard_Data2, KeyBoard_Data2_End
	VCMD_SET	$00, $2186, KeyBoard_Data1, KeyBoard_Data1_End
	VCMD_SET	$80, $21a6, KeyBoard_Data2, KeyBoard_Data2_End
	VCMD_SET	$00, $21e6, KeyBoard_Data1, KeyBoard_Data1_End
	VCMD_SET	$00, $2206, KeyBoard_Data2, KeyBoard_Data2_End
	VCMD_SET	$00, $2246, KeyBoard_Data1, KeyBoard_Data1_End
	VCMD_SET	$80, $2266, KeyBoard_Data2, KeyBoard_Data2_End
	VCMD_SET	$c0, $22ae, KeyBoard_Data3, KeyBoard_Data3_End

